<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content interface">
                   <div class="content-data">












<ol class="breadcrumb">
  <li>Interfaces</li>
  <li>INameCheck</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/services/users/services/users.service.ts</code>
        </p>



        <section>
            <h3 id="index">Index</h3>
            <table class="table table-sm table-bordered index-table">
                <tbody>
                    <tr>
                        <td class="col-md-4">
                            <h6><b>Properties</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                        <a href="#username">username</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
        </section>



            <section>
                <h3 id="inputs">Properties</h3>
                    <table class="table table-sm table-bordered">
                        <tbody>
                                <tr>
                                    <td class="col-md-4">
                                        <a name="username"></a>
                                        <span class="name"><b>username</b><a href="#username"><span class="icon ion-ios-link"></span></a></span>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="col-md-4">
                                        <code>username:     <code>T</code>
</code>
                                    </td>
                                </tr>


                                    <tr>
                                        <td class="col-md-4">
                                            <i>Type : </i>    <code>T</code>

                                        </td>
                                    </tr>





                        </tbody>
                    </table>
            </section>
    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable, Logger } from &#x27;@nestjs/common&#x27;
import { ObjectId } from &#x27;mongodb&#x27;
import { CommandBus, EventPublisher } from &#x27;@nestjs/cqrs&#x27;
import {
    getUserByUsername, checkIfUsernameExists, getUserByProp, getPasswordById, addSocialAccountToUser, getUserByDocument, updateFireUserByValuePairs
} from &#x27;./../repositories/user-firebase.repository&#x27;
// import { toDataURL } from &#x27;qrcode&#x27;
// import * as QRCode from &#x27;qrcode&#x27;
// import * as jimp from &#x27;jimp&#x27;
import { UserEventHandle } from &#x27;../events/users.aggregate&#x27;
import { createHmac } from &#x27;crypto&#x27;
import { updateUserElementInArray, updateMongoUserByValuePairs, getMongoUserByProp, getMongoUsersByIds } from &#x27;../repositories/user.repository&#x27;
import { objectToValuePairs } from &#x27;src/common/utility/pipe-utility&#x27;
import { IMongoEntity, IFirestoreEntity, IMongoStringEntity } from &#x27;src/models/common/common&#x27;
import { IUserFireEntity, IUserMongoEntity, INotificationCredential, IUserEntityBaseArrayMap } from &#x27;../models&#x27;
import { ISocialAccount, SocialProviders } from &#x27;../models/social-account&#x27;
// import { checkIfNameExists } from &#x27;../players/players.repository&#x27;
// import { CurrencyService } from &#x27;../currency/currency.service&#x27;

// http://thecodebarbarian.com/creating-qr-codes-with-node-js.html

interface ICreateUserParams {
    username: string
    password: string
    // player_name: string
    // family_name: string
}

interface ICreateUserParamsBase {
    username: string
    password: string
    email: string
    access_token: string
    first_name: string
    last_name: string
    avatar: string
    avatar_url: string
    private_account: boolean
    use_real_name: boolean
}

interface ICreateMongoUserParams extends ICreateUserParamsBase, IMongoEntity, IFirestoreEntity {
}

interface ICreateFireUserParams extends ICreateUserParamsBase, IFirestoreEntity, IMongoStringEntity {
}

interface INameCheck&lt;T extends string | boolean&gt; {
    username: T
    // player_name: T
    // family_name: T
}

@Injectable()
export class UsersService {
    private readonly logger &#x3D; new Logger(UsersService.name)
    private readonly eventHandle: UserEventHandle

    constructor(
        private readonly commandBus: CommandBus,
        // private readonly eventBus: EventBus,
        private readonly publisher: EventPublisher,
        // private readonly currencyService: CurrencyService,
    ) {
        this.eventHandle &#x3D;
            publisher.mergeObjectContext(
                new UserEventHandle(new ObjectId().toHexString()))
        this.eventHandle.autoCommit &#x3D; true
    }

    async createUserFromFirebase(payload: ICreateFireUserParams) {
        const body_values &#x3D; Object.values(payload)

        if (body_values.some((s) &#x3D;&gt; s &#x3D;&#x3D;&#x3D; undefined)) {
            return {
                id: &#x27;&#x27;,
                access_token: &#x27;&#x27;,
                validation_passed: false,
            }
        }
        const {
            _id,
            fire_id,
            username,
            password,
            email,
            access_token,
            first_name,
            last_name,
            avatar,
            avatar_url,
            private_account,
            use_real_name,
        } &#x3D; payload

        const hash &#x3D;
            createHmac(&#x27;sha512&#x27;, process.env.ACCOUNT_KEY)
                .update(access_token)
                .digest(&#x27;hex&#x27;)

        let account: ISocialAccount &#x3D; {
            id: &#x27;&#x27;,
            access_token: hash,
            email: &#x27;&#x27;,
            provider: SocialProviders.FACEBOOK,
            username: &#x27;&#x27;,
        }

        let user_id &#x3D;
            await this.eventHandle
                .createUser(
                    fire_id,
                    _id,
                    username,
                    password,
                    email,
                    account,
                    first_name,
                    last_name,
                    avatar,
                    avatar_url,
                    private_account,
                    use_real_name)

        // let res &#x3D; await addSocialAccountToUser(id, access_token)

        return {
            id: user_id,
            access_token: access_token,
            validation_passed: true,
        }
    }

    async addSocialAccountToUser(user_id: string, access_token: string) {
        return await this.eventHandle
            .addSocialAccountToUser(user_id, access_token)
    }

    async findMongoUserById(user_id: ObjectId) {
        let res &#x3D; await getMongoUserByProp(&#x27;_id&#x27;, user_id)
        return res
    }

    async findMongoUsersByIds(user_ids: ObjectId[]) {
        let res &#x3D; await getMongoUsersByIds(user_ids)
        return res
    }

    async findOne(prop: keyof IUserFireEntity, input: string): Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByProp(prop, input)

        if (user !&#x3D;&#x3D; null) {
            return user
        } else {
            return null
        }
    }

    async findOneByDocument(input: string): Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByDocument(input)

        if (user !&#x3D;&#x3D; null) {
            return user
        } else {
            return null
        }
    }

    async findOneAdminByDocument(input: string): Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByDocument(input)

        if (user !&#x3D;&#x3D; null &amp;&amp;
            user.is_admin) {
            return user
        } else {
            return null
        }
    }

    async findOneByDocumentAndBusiness(input: string):
        Promise&lt;IUserFireEntity | null&gt; {
        const user &#x3D; await getUserByDocument(input)

        if (user !&#x3D;&#x3D; null &amp;&amp;
            user.is_admin) {
            return user
        } else {
            return null
        }
    }

    async findByUserName(username: string): Promise&lt;IUserFireEntity | undefined&gt; {
        const user &#x3D; await getUserByUsername(username)

        if (user !&#x3D;&#x3D; null) {
            return user
        } else {
            return null
        }
    }

    async checkIdAvailability(
        id: string
    ) {
    }

    async checkNameAvailability(
        name: string,
        // prop: &#x27;username&#x27; | &#x27;player_name&#x27; | &#x27;family_name&#x27; &#x3D; &#x27;username&#x27;
        prop: &#x27;username&#x27; &#x3D; &#x27;username&#x27;
    ) {
        if (prop &#x3D;&#x3D;&#x3D; &#x27;username&#x27;) {
            return await checkIfUsernameExists(name)
        } else {
            // return await checkIfNameExists(name, prop)
        }
    }

    private nameCheck &#x3D; (input: string, minLength: number &#x3D; 3, maxLength: number &#x3D; 15) &#x3D;&gt; {
        const spaceCheck &#x3D; new RegExp(/\s/)
        if (input.length &gt;&#x3D; 3 &amp;&amp;
            input.length &lt;&#x3D; 15 &amp;&amp;
            !spaceCheck.test(input)) {
            return true
        } else {
            return false
        }
    }

    private checkIfNamesAreValid(username: string) {

        const u &#x3D; this.nameCheck(username)

        const res: INameCheck&lt;boolean&gt; &#x3D; {
            username: u,
        }

        return res
    }

    async checkIfNamesAreAvailable(username: string) {
        const nres &#x3D; this.checkIfNamesAreValid(username)
        const entries: boolean[] &#x3D; Object.values(nres)

        if (entries.some(s &#x3D;&gt; s &#x3D;&#x3D;&#x3D; false)) {
            return nres
        }

        const usernameExists &#x3D;
            await this.checkNameAvailability(username, &#x27;username&#x27;)

        const res: INameCheck&lt;boolean&gt; &#x3D; {
            username: !usernameExists,
        }

        return res
    }

    async getPassword(user_id: ObjectId) {
        const pw &#x3D; await getPasswordById(user_id)

        if (pw !&#x3D;&#x3D; null) {
            return pw
        } else {
            return null
        }
    }

    async getMongoUserByProp&lt;
        T extends IUserMongoEntity,
        K extends keyof T
    &gt;(
        prop: K,
        value: T[K],
    ) {
        try {
            let res &#x3D; await getMongoUserByProp(prop, value)
            return res
        } catch (error) {
            this.logger.error(error)
            return null
        }
    }

    async updateMongoUserByValuePair&lt;
        T extends IUserMongoEntity,
        K extends keyof IUserMongoEntity,
        &gt;(
            user_id: ObjectId,
            prop: K,
            value: T[K],
    ) {
        let res &#x3D; await updateMongoUserByValuePairs(user_id, [{
            prop,
            value,
        }])
        return res
    }

    // async updateNotificationCredentials&lt;
    //     T extends Partial&lt;INotificationCredential&gt;,
    //     K extends keyof Partial&lt;INotificationCredential&gt;
    // &gt;(
    //     user_id: ObjectId,
    //     pairs: {
    //         prop: K,
    //         value: T[K],
    //     }[],
    //     array_filters: {
    //         prop: K,
    //         value: T[K],
    //     }[],
    // ) {

    // }

    async updateNotificationCredentials(
        user_id: ObjectId,
        entity: INotificationCredential,
        array_filters: Partial&lt;INotificationCredential&gt;,
    ) {
        let res &#x3D;
            await updateUserElementInArray(
                user_id,
                &#x27;notification_credentials&#x27;,
                entity,
                array_filters)

        this.logger.debug(this.updateNotificationCredentials.name)
        console.log(res)

        return res
        // let pairs &#x3D; objectToValuePairs(entity)
        // let filters &#x3D; objectToValuePairs(array_filters)
        // let res &#x3D;
        //     await updateElementInArray(user_id, [
        //         {
        //             array_prop: &#x27;notification_credentials&#x27;,
        //             prop: 
        //         }
        //     ])
    }

    async updateUserElementInArray&lt;
        // K extends keyof Pick&lt;IUserEntityBase, &#x27;notification_credentials&#x27; | &#x27;roles&#x27; | &#x27;role_access&#x27; | &#x27;social_accounts&#x27;&gt;,
        // T extends IUserEntityBaseArrayMap,
        // P extends keyof T,
        // V extends T[P],
        // U extends keyof T[P],
        P extends keyof IUserEntityBaseArrayMap,
        U extends keyof IUserEntityBaseArrayMap[P],
        V extends IUserEntityBaseArrayMap[P],
        U2 extends keyof IUserEntityBaseArrayMap[P],
        V2 extends IUserEntityBaseArrayMap[P],
        &gt;(
            user_id: ObjectId,
            pairs: {
                // array_prop: K,
                array_prop: P,
                prop: U,
                value: V[U]
            }[],
            array_filters: {
                prop: U2,
                value: V2[U2]
            }[],
        // array_filters: {
        //     prop: P,
        //     value: U[P]
        // }[],
    ) {
        // // let res &#x3D; await updateMongoUserByValuePairs(user_id, [{
        // //     prop,
        // //     value,
        // // }])
        // // return res

        // let res &#x3D;
        //     await updateElementInArray(user_id, pairs, [
        //         {
        //             prop: &#x27;device_id&#x27;,
        //             value: &#x27;&#x27;,
        //         }
        //     ])
        // return res
    }

    async updateFireUserByValuePair&lt;
        T extends IUserFireEntity,
        K extends keyof IUserFireEntity,
        &gt;(
            user_id: string,
            prop: K,
            value: T[K],
    ) {
        let res &#x3D; await updateFireUserByValuePairs(user_id, [{
            prop,
            value,
        }])
        return res
    }
}</code></pre>
    </div>
</div>


                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'interface';
            var COMPODOC_CURRENT_PAGE_URL = 'INameCheck-1.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
